import * as tailwind_factory_dist from 'tailwind-factory/dist';
import * as react from 'react';
import { CSSProperties, ComponentProps, KeyboardEvent, ChangeEvent, FocusEvent } from 'react';
import { PrismTheme } from 'prism-react-renderer';

declare const HighlightContainer: ((props: react.ClassAttributes<HTMLDivElement> & react.HTMLAttributes<HTMLDivElement> & Partial<tailwind_factory_dist.FactoryExtractKeys<{
    full: {
        true: string;
        false: string;
    };
}>> & Required<Omit<tailwind_factory_dist.FactoryExtractKeys<{
    full: {
        true: string;
        false: string;
    };
}>, "full">>) => JSX.Element) & {
    __extends: <NewType extends tailwind_factory_dist.FactoryElement | null, NewStyleVariants, NewDefaultStyleVariants, NewDefaultStyleVariantsScheme extends tailwind_factory_dist.FactoryExtractKeys<tailwind_factory_dist.FactoryExtractRequiredKeysAndValues<{
        full: {
            true: string;
            false: string;
        };
    }> & NewStyleVariants>>(newElement?: NewType | undefined, newStyles?: string | undefined, newConfig?: tailwind_factory_dist.StyledElementOptions<NewStyleVariants & tailwind_factory_dist.FactoryExtractKeysAndValues<{
        full: {
            true: string;
            false: string;
        };
    }>, NewDefaultStyleVariants, NewDefaultStyleVariantsScheme> | undefined) => ((props: (NewType extends tailwind_factory_dist.FactoryElement ? react.ComponentProps<NewType> : react.DetailedHTMLProps<react.HTMLAttributes<HTMLDivElement>, HTMLDivElement>) & (NewDefaultStyleVariants extends infer C_1 ? Partial<{
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1 ? tailwind_factory_dist.FactoryExtractKeys<U_1> : any> & Required<Omit<{
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1_1 ? tailwind_factory_dist.FactoryExtractKeys<U_1_1> : any, "full" | keyof C_1>> : {
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1_2 ? tailwind_factory_dist.FactoryExtractKeys<U_1_2> : any)) => JSX.Element) & {
        __extends: any;
    };
};

declare const definedTokens: readonly ["char", "cdata", "doctype", "entity", "class-name", "boolean", "property", "function", "mayble-class-name", "method", "function-variable", "variable", "attr-name", "punctuation", "operator", "control-flow", "markup", "tag", "atrule", "deleted", "selector", "url", "string", "attr-value", "template-punctuation", "constant", "number", "builtin", "changed", "keyword", "interpolation-punctuation", "comment", "inserted", "important", "content", "null", "prolog", "blockquote", "hr", "code-snippet", "italic", "style", "bold", "strike", "list", "title", "property-line", "property-declaration", "hexcode", "unit", "macro", "directive-hash"];
declare const tokens: readonly ["char", "cdata", "doctype", "entity", "class-name", "boolean", "property", "function", "mayble-class-name", "method", "function-variable", "variable", "attr-name", "punctuation", "operator", "control-flow", "markup", "tag", "atrule", "deleted", "selector", "url", "string", "attr-value", "template-punctuation", "constant", "number", "builtin", "changed", "keyword", "interpolation-punctuation", "comment", "inserted", "important", "content", "null", "prolog", "blockquote", "hr", "code-snippet", "italic", "style", "bold", "strike", "list", "title", "property-line", "property-declaration", "hexcode", "unit", "macro", "directive-hash", String];
type DefinedGrammarToken = (typeof definedTokens)[number];
type GrammarToken = (typeof tokens)[number];

type HighlightLanguageInput = [
  "markup",
  "html",
  "xml",
  "svg",
  "mathml",
  "ssml",
  "atom",
  "rss",
  "css",
  "clike",
  "javascript",
  "js",
  "abap",
  "abnf",
  "actionscript",
  "ada",
  "agda",
  "al",
  "antlr4",
  "g4",
  "apacheconf",
  "apex",
  "apl",
  "applescript",
  "aql",
  "arduino",
  "ino",
  "arff",
  "armasm",
  "arm-asm",
  "arturo",
  "art",
  "asciidoc",
  "adoc",
  "aspnet",
  "asm6502",
  "asmatmel",
  "autohotkey",
  "autoit",
  "avisynth",
  "avs",
  "avro-idl",
  "avdl",
  "awk",
  "gawk",
  "bash",
  "sh",
  "shell",
  "basic",
  "batch",
  "bbcode",
  "shortcode",
  "bbj",
  "bicep",
  "birb",
  "bison",
  "bnf",
  "rbnf",
  "bqn",
  "brainfuck",
  "brightscript",
  "bro",
  "bsl",
  "oscript",
  "c",
  "csharp",
  "cs",
  "dotnet",
  "cpp",
  "cfscript",
  "cfc",
  "chaiscript",
  "cil",
  "cilkc",
  "cilk-c",
  "cilkcpp",
  "cilk-cpp",
  "cilk",
  "clojure",
  "cmake",
  "cobol",
  "coffeescript",
  "coffee",
  "concurnas",
  "conc",
  "csp",
  "cooklang",
  "coq",
  "crystal",
  "css-extras",
  "csv",
  "cue",
  "cypher",
  "d",
  "dart",
  "dataweave",
  "dax",
  "dhall",
  "diff",
  "django",
  "jinja2",
  "dns-zone-file",
  "dns-zone",
  "docker",
  "dockerfile",
  "dot",
  "gv",
  "ebnf",
  "editorconfig",
  "eiffel",
  "ejs",
  "eta",
  "elixir",
  "elm",
  "etlua",
  "erb",
  "erlang",
  "excel-formula",
  "xlsx",
  "xls",
  "fsharp",
  "factor",
  "false",
  "firestore-security-rules",
  "flow",
  "fortran",
  "ftl",
  "gml",
  "gamemakerlanguage",
  "gap",
  "gcode",
  "gdscript",
  "gedcom",
  "gettext",
  "po",
  "gherkin",
  "git",
  "glsl",
  "gn",
  "gni",
  "linker-script",
  "ld",
  "go",
  "go-module",
  "go-mod",
  "gradle",
  "graphql",
  "groovy",
  "haml",
  "handlebars",
  "hbs",
  "mustache",
  "haskell",
  "hs",
  "haxe",
  "hcl",
  "hlsl",
  "hoon",
  "http",
  "hpkp",
  "hsts",
  "ichigojam",
  "icon",
  "icu-message-format",
  "idris",
  "idr",
  "ignore",
  "gitignore",
  "hgignore",
  "npmignore",
  "inform7",
  "ini",
  "io",
  "j",
  "java",
  "javadoc",
  "javadoclike",
  "javastacktrace",
  "jexl",
  "jolie",
  "jq",
  "jsdoc",
  "js-extras",
  "json",
  "webmanifest",
  "json5",
  "jsonp",
  "jsstacktrace",
  "js-templates",
  "julia",
  "keepalived",
  "keyman",
  "kotlin",
  "kt",
  "kts",
  "kumir",
  "kum",
  "kusto",
  "latex",
  "tex",
  "context",
  "latte",
  "less",
  "lilypond",
  "ly",
  "liquid",
  "lisp",
  "emacs",
  "elisp",
  "emacs-lisp",
  "livescript",
  "llvm",
  "log",
  "lolcode",
  "lua",
  "magma",
  "makefile",
  "markdown",
  "md",
  "markup-templating",
  "mata",
  "matlab",
  "maxscript",
  "mel",
  "mermaid",
  "metafont",
  "mizar",
  "mongodb",
  "monkey",
  "moonscript",
  "moon",
  "n1ql",
  "n4js",
  "n4jsd",
  "nand2tetris-hdl",
  "naniscript",
  "nani",
  "nasm",
  "neon",
  "nevod",
  "nginx",
  "nim",
  "nix",
  "nsis",
  "objectivec",
  "objc",
  "ocaml",
  "odin",
  "opencl",
  "openqasm",
  "qasm",
  "oz",
  "parigp",
  "parser",
  "pascal",
  "objectpascal",
  "pascaligo",
  "psl",
  "pcaxis",
  "px",
  "peoplecode",
  "pcode",
  "perl",
  "php",
  "phpdoc",
  "php-extras",
  "plant-uml",
  "plantuml",
  "plsql",
  "powerquery",
  "pq",
  "mscript",
  "powershell",
  "processing",
  "prolog",
  "promql",
  "properties",
  "protobuf",
  "pug",
  "puppet",
  "pure",
  "purebasic",
  "pbfasm",
  "purescript",
  "purs",
  "python",
  "py",
  "qsharp",
  "qs",
  "q",
  "qml",
  "qore",
  "r",
  "racket",
  "rkt",
  "cshtml",
  "razor",
  "jsx",
  "tsx",
  "reason",
  "regex",
  "rego",
  "renpy",
  "rpy",
  "rescript",
  "res",
  "rest",
  "rip",
  "roboconf",
  "robotframework",
  "robot",
  "ruby",
  "rb",
  "rust",
  "sas",
  "sass",
  "scss",
  "scala",
  "scheme",
  "shell-session",
  "sh-session",
  "shellsession",
  "smali",
  "smalltalk",
  "smarty",
  "sml",
  "smlnj",
  "solidity",
  "sol",
  "solution-file",
  "sln",
  "soy",
  "sparql",
  "rq",
  "splunk-spl",
  "sqf",
  "sql",
  "squirrel",
  "stan",
  "stata",
  "iecst",
  "stylus",
  "supercollider",
  "sclang",
  "swift",
  "systemd",
  "t4-templating",
  "t4-cs",
  "t4",
  "t4-vb",
  "tap",
  "tcl",
  "tt2",
  "textile",
  "toml",
  "tremor",
  "trickle",
  "troy",
  "turtle",
  "trig",
  "twig",
  "typescript",
  "ts",
  "typoscript",
  "tsconfig",
  "unrealscript",
  "uscript",
  "uc",
  "uorazor",
  "uri",
  "url",
  "v",
  "vala",
  "vbnet",
  "velocity",
  "verilog",
  "vhdl",
  "vim",
  "visual-basic",
  "vb",
  "vba",
  "warpscript",
  "wasm",
  "web-idl",
  "webidl",
  "wgsl",
  "wiki",
  "wolfram",
  "mathematica",
  "nb",
  "wl",
  "wren",
  "xeora",
  "xeoracube",
  "xml-doc",
  "xojo",
  "xquery",
  "yaml",
  "yml",
  "yang",
  "zig"
][number];

type HighlightLanguageComponent = [
  "markup",
  "css",
  "clike",
  "javascript",
  "abap",
  "abnf",
  "actionscript",
  "ada",
  "agda",
  "al",
  "antlr4",
  "apacheconf",
  "apex",
  "apl",
  "applescript",
  "aql",
  "arduino",
  "arff",
  "armasm",
  "arturo",
  "asciidoc",
  "aspnet",
  "asm6502",
  "asmatmel",
  "autohotkey",
  "autoit",
  "avisynth",
  "avro-idl",
  "awk",
  "bash",
  "basic",
  "batch",
  "bbcode",
  "bbj",
  "bicep",
  "birb",
  "bison",
  "bnf",
  "bqn",
  "brainfuck",
  "brightscript",
  "bro",
  "bsl",
  "c",
  "csharp",
  "cpp",
  "cfscript",
  "chaiscript",
  "cil",
  "cilkc",
  "cilkcpp",
  "clojure",
  "cmake",
  "cobol",
  "coffeescript",
  "concurnas",
  "csp",
  "cooklang",
  "coq",
  "crystal",
  "css-extras",
  "csv",
  "cue",
  "cypher",
  "d",
  "dart",
  "dataweave",
  "dax",
  "dhall",
  "diff",
  "django",
  "dns-zone-file",
  "docker",
  "dot",
  "ebnf",
  "editorconfig",
  "eiffel",
  "ejs",
  "elixir",
  "elm",
  "etlua",
  "erb",
  "erlang",
  "excel-formula",
  "fsharp",
  "factor",
  "false",
  "firestore-security-rules",
  "flow",
  "fortran",
  "ftl",
  "gml",
  "gap",
  "gcode",
  "gdscript",
  "gedcom",
  "gettext",
  "gherkin",
  "git",
  "glsl",
  "gn",
  "linker-script",
  "go",
  "go-module",
  "gradle",
  "graphql",
  "groovy",
  "haml",
  "handlebars",
  "haskell",
  "haxe",
  "hcl",
  "hlsl",
  "hoon",
  "http",
  "hpkp",
  "hsts",
  "ichigojam",
  "icon",
  "icu-message-format",
  "idris",
  "ignore",
  "inform7",
  "ini",
  "io",
  "j",
  "java",
  "javadoc",
  "javadoclike",
  "javastacktrace",
  "jexl",
  "jolie",
  "jq",
  "jsdoc",
  "js-extras",
  "json",
  "json5",
  "jsonp",
  "jsstacktrace",
  "js-templates",
  "julia",
  "keepalived",
  "keyman",
  "kotlin",
  "kumir",
  "kusto",
  "latex",
  "latte",
  "less",
  "lilypond",
  "liquid",
  "lisp",
  "livescript",
  "llvm",
  "log",
  "lolcode",
  "lua",
  "magma",
  "makefile",
  "markdown",
  "markup-templating",
  "mata",
  "matlab",
  "maxscript",
  "mel",
  "mermaid",
  "metafont",
  "mizar",
  "mongodb",
  "monkey",
  "moonscript",
  "n1ql",
  "n4js",
  "nand2tetris-hdl",
  "naniscript",
  "nasm",
  "neon",
  "nevod",
  "nginx",
  "nim",
  "nix",
  "nsis",
  "objectivec",
  "ocaml",
  "odin",
  "opencl",
  "openqasm",
  "oz",
  "parigp",
  "parser",
  "pascal",
  "pascaligo",
  "psl",
  "pcaxis",
  "peoplecode",
  "perl",
  "php",
  "phpdoc",
  "php-extras",
  "plant-uml",
  "plsql",
  "powerquery",
  "powershell",
  "processing",
  "prolog",
  "promql",
  "properties",
  "protobuf",
  "pug",
  "puppet",
  "pure",
  "purebasic",
  "purescript",
  "python",
  "qsharp",
  "q",
  "qml",
  "qore",
  "r",
  "racket",
  "cshtml",
  "jsx",
  "tsx",
  "reason",
  "regex",
  "rego",
  "renpy",
  "rescript",
  "rest",
  "rip",
  "roboconf",
  "robotframework",
  "ruby",
  "rust",
  "sas",
  "sass",
  "scss",
  "scala",
  "scheme",
  "shell-session",
  "smali",
  "smalltalk",
  "smarty",
  "sml",
  "solidity",
  "solution-file",
  "soy",
  "sparql",
  "splunk-spl",
  "sqf",
  "sql",
  "squirrel",
  "stan",
  "stata",
  "iecst",
  "stylus",
  "supercollider",
  "swift",
  "systemd",
  "t4-templating",
  "t4-cs",
  "t4-vb",
  "tap",
  "tcl",
  "tt2",
  "textile",
  "toml",
  "tremor",
  "turtle",
  "twig",
  "typescript",
  "typoscript",
  "unrealscript",
  "uorazor",
  "uri",
  "v",
  "vala",
  "vbnet",
  "velocity",
  "verilog",
  "vhdl",
  "vim",
  "visual-basic",
  "warpscript",
  "wasm",
  "web-idl",
  "wgsl",
  "wiki",
  "wolfram",
  "wren",
  "xeora",
  "xml-doc",
  "xojo",
  "xquery",
  "yaml",
  "yang",
  "zig"
][number];

/**
 * Common properties used to style code. If you want to use properties
 * that aren't available there, try using the `DangerousStyleEntry`.
 *
 * But use at your own risk.
 */
type StyleEntry = {
    color?: string;
    backgroundColor?: string;
    fontStyle?: "normal" | "italic";
    fontWeight?: "normal" | "bold" | "100" | "200" | "300" | "400" | "500" | "600" | "700" | "800" | "900";
    textDecorationLine?: "none" | "underline" | "line-through" | "underline line-through";
    opacity?: number;
};
/**
 * Properties that aren't available in `StyleEntry`.
 *
 * Use at your own risk.
 */
type DangerousStyleEntry = CSSProperties & StyleEntry;
/**
 * Code container styling.
 */
type HighlightThemePlain = PrismTheme["plain"] & {
    numbersColor?: string;
    numbersBackgroundColor?: string;
    numbersBorderColor?: string;
    srollbarThumbColor?: string;
    scrollbarTrackColor?: string;
};
/**
 * Rule of styles used in each token.
 */
type HighlightThemeStyle = {
    types: GrammarToken[];
    style: StyleEntry;
    languages?: (HighlightLanguageComponent | String)[];
};
interface HighlightTheme extends Omit<PrismTheme, "styles"> {
    plain: HighlightThemePlain;
    styles: HighlightThemeStyle[];
}
declare class HighlightCustomTheme implements HighlightTheme {
    plain: HighlightThemePlain;
    styles: HighlightThemeStyle[];
    /**
     * Create a new theme
     *
     * @param plain - code's contianer styles
     * @param styles - code's line styles
     */
    constructor(plain: HighlightThemePlain, styles?: HighlightThemeStyle[]);
    /**
     *
     * @param theme - theme to extends
     * @param plain - new code's contianer styles
     * @param styles - new code's line styles
     */
    static extends(theme: HighlightTheme, plain: HighlightThemePlain, styles?: HighlightThemeStyle[]): HighlightCustomTheme;
}

declare const themes: {
    oneDark: HighlightCustomTheme;
    dracula: HighlightTheme;
    duotoneDark: HighlightTheme;
    duotoneLight: HighlightTheme;
    github: HighlightTheme;
    nightOwl: HighlightTheme;
    nightOwlLight: HighlightTheme;
    oceanicNext: HighlightTheme;
    palenight: HighlightTheme;
    okaidia: HighlightTheme;
    shadesOfPurple: HighlightTheme;
    synthwave84: HighlightTheme;
    ultramin: HighlightTheme;
    vsDark: HighlightTheme;
    vsLight: HighlightTheme;
};

type SpanProps = ComponentProps<"span">;
type DivProps = ComponentProps<"span">;
/**
 * A common token used in rendering, not to be confused
 * with the token format passed in language definitions.
 */
type Token = {
    /**
     * The passed token and its aliases
     */
    types: string[];
    /**
     * The content related to the token, typically a snippet of the rendered line.
     */
    content: string;
    /**
     * Says if the token is empty
     */
    empty?: boolean;
};
type StyleObj = CSSProperties & {
    [key: string]: string | number | null;
};
/**
 * Line properties before being processed and rendered.
 */
type LineInputProps = DivProps & {
    key?: React.Key;
    style?: StyleObj;
    className?: string;
    line: Token[];
};
/**
 * Line properties after being processed and before rendered.
 */
type LineOutputProps = DivProps & {
    key?: React.Key;
    style?: StyleObj;
    readonly className: string;
};
/**
 * Properties of the token to be inserted into the line
 * before it is processed and rendered.
 */
type TokenInputProps = SpanProps & {
    key?: React.Key;
    style?: StyleObj;
    className?: string;
    token: Token;
};
/**
 * Properties of the token to be inserted into the line
 * after it is processed and before rendered.
 */
type TokenOutputProps = SpanProps & {
    key?: React.Key;
    style?: StyleObj;
    className: string;
    readonly children: string;
};
type HighligthPluginData<Settings> = {
    /**
     * Use this function to change the theme in use.
     *
     * @param settings - plugin's settings
     * @param theme - theme in use
     * @param highlightProps - main highlight properties
     *
     * @returns formatted theme
     */
    theme?: (settings: Settings, theme: HighlightCustomTheme, highlightProps: CoreHighlightProps) => HighlightCustomTheme;
    /**
     * Use this function to change the current code.
     *
     * @param settings - plugin's settings
     * @param code - current code
     * @param highlightProps - main highlight properties
     *
     * @returns formatted code
     */
    code?: (settings: Settings, code: string, highlightProps: CoreHighlightProps) => string;
    /**
     * Use this function to change the token input.
     *
     * The `token input` is nothing more than the properties that will be passed
     * inside the `spans` rendered on each line for each token.
     *
     * What you pass here will still be processed by the `prism-react-renderer` function.
     *
     * @param settings - plugin's settings
     * @param props - token input props
     * @param highlightProps - main highlight properties
     *
     * @returns formatted token input
     */
    tokenInput?: (settings: Settings, props: TokenInputProps, highlightProps: CoreHighlightProps) => TokenInputProps;
    /**
     * Use this function to change the token output.
     *
     * The `token output` is nothing more than the properties that will be passed
     * inside the `span` rendered on each line for each token after be
     * processed by the `prism-react-renderer` function.
     *
     * @param settings - plugin's settings
     * @param props - token output props
     * @param highlightProps - main highlight properties
     *
     * @returns formatted token output
     */
    tokenOutput?: (settings: Settings, props: TokenOutputProps, highlightProps: CoreHighlightProps) => TokenOutputProps;
    /**
     * Use this function to change the line input.
     *
     * The `line input` is nothing more than the properties that will be passed
     * inside the `div` rendered for each line.
     *
     * What you pass here will still be processed by the `prism-react-renderer` function.
     *
     * @param settings - plugin's settings
     * @param props - line input props
     * @param highlightProps - main highlight properties
     *
     * @returns formatted line input
     */
    lineInput?: (settings: Settings, props: LineInputProps, highlightProps: CoreHighlightProps) => LineInputProps;
    /**
     * Use this function to change the line ouput.
     *
     * The `line ouput` is nothing more than the properties that will be passed
     * inside the `div` rendered for each line after be
     * processed by the `prism-react-renderer` function.
     *
     * @param settings - plugin's settings
     * @param props - line ouput props
     * @param highlightProps - main highlight properties
     *
     * @returns formatted line ouput
     */
    lineOutput?: (settings: Settings, props: LineOutputProps, highlightProps: CoreHighlightProps) => LineOutputProps;
    /**
     * Use this function to modify the array of tokens representing lines of code.
     *
     * @param settings - plugin's settings
     * @param tokens - array of tokens
     * @param highlightProps - main highlight properties
     *
     * @returns formatted array of tokens
     */
    codeLines?: (settings: Settings, tokens: Token[][], highlightProps: CoreHighlightProps) => Token[][];
    /**
     * Use this function to modify the tokens inside each lines of code.
     *
     * @param settings - plugin's settings
     * @param tokens - the tokens
     * @param highlightProps - main highlight properties
     *
     * @returns formatted tokens
     */
    codeLine?: (settings: Settings, tokens: Token[], highlightProps: CoreHighlightProps) => Token[];
};
declare class HighligthPlugin<Settings> {
    plugin: HighligthPluginData<Settings>;
    settings: Settings;
    /**
     * This function is private, use the static `create` method instead.
     */
    private constructor();
    /**
     * Create a new plugin.
     *
     * It is important to pass the typing of the plugin settings
     * in the generic if you are using typescript!
     *
     * @param plugin - the methods of your plugin
     * @param defaultSettings - plugin default settings
     * @returns plugin instance
     */
    static create<Settings>(plugin: HighligthPluginData<Settings>, defaultSettings: Settings): (settings?: Settings) => HighligthPlugin<Settings>;
}

declare function getAllLanguagesInputs(): string[];
declare function getAllLanguagesComponents(): string[];

declare function getComponents(): {
    core: {
        meta: {
            path: string;
            option: string;
        };
        core: string;
    };
    themes: {
        meta: {
            path: string;
            link: string;
            exclusive: boolean;
        };
        prism: {
            title: string;
            option: string;
        };
        "prism-dark": string;
        "prism-funky": string;
        "prism-okaidia": {
            title: string;
            owner: string;
        };
        "prism-twilight": {
            title: string;
            owner: string;
        };
        "prism-coy": {
            title: string;
            owner: string;
        };
        "prism-solarizedlight": {
            title: string;
            owner: string;
        };
        "prism-tomorrow": {
            title: string;
            owner: string;
        };
    };
    languages: {
        meta: {
            path: string;
            noCSS: boolean;
            examplesPath: string;
            addCheckAll: boolean;
        };
        markup: {
            title: string;
            alias: string[];
            aliasTitles: {
                html: string;
                xml: string;
                svg: string;
                mathml: string;
                ssml: string;
                atom: string;
                rss: string;
            };
            option: string;
        };
        css: {
            title: string;
            option: string;
            modify: string;
        };
        clike: {
            title: string;
            option: string;
        };
        javascript: {
            title: string;
            require: string;
            modify: string;
            optional: string;
            alias: string;
            option: string;
        };
        abap: {
            title: string;
            owner: string;
        };
        abnf: {
            title: string;
            owner: string;
        };
        actionscript: {
            title: string;
            require: string;
            modify: string;
            owner: string;
        };
        ada: {
            title: string;
            owner: string;
        };
        agda: {
            title: string;
            owner: string;
        };
        al: {
            title: string;
            owner: string;
        };
        antlr4: {
            title: string;
            alias: string;
            owner: string;
        };
        apacheconf: {
            title: string;
            owner: string;
        };
        apex: {
            title: string;
            require: string[];
            owner: string;
        };
        apl: {
            title: string;
            owner: string;
        };
        applescript: {
            title: string;
            owner: string;
        };
        aql: {
            title: string;
            owner: string;
        };
        arduino: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        arff: {
            title: string;
            owner: string;
        };
        armasm: {
            title: string;
            alias: string;
            owner: string;
        };
        arturo: {
            title: string;
            alias: string;
            optional: string[];
            owner: string;
        };
        asciidoc: {
            alias: string;
            title: string;
            owner: string;
        };
        aspnet: {
            title: string;
            require: string[];
            owner: string;
        };
        asm6502: {
            title: string;
            owner: string;
        };
        asmatmel: {
            title: string;
            owner: string;
        };
        autohotkey: {
            title: string;
            owner: string;
        };
        autoit: {
            title: string;
            owner: string;
        };
        avisynth: {
            title: string;
            alias: string;
            owner: string;
        };
        "avro-idl": {
            title: string;
            alias: string;
            owner: string;
        };
        awk: {
            title: string;
            alias: string;
            aliasTitles: {
                gawk: string;
            };
            owner: string;
        };
        bash: {
            title: string;
            alias: string[];
            aliasTitles: {
                sh: string;
                shell: string;
            };
            owner: string;
        };
        basic: {
            title: string;
            owner: string;
        };
        batch: {
            title: string;
            owner: string;
        };
        bbcode: {
            title: string;
            alias: string;
            aliasTitles: {
                shortcode: string;
            };
            owner: string;
        };
        bbj: {
            title: string;
            owner: string;
        };
        bicep: {
            title: string;
            owner: string;
        };
        birb: {
            title: string;
            require: string;
            owner: string;
        };
        bison: {
            title: string;
            require: string;
            owner: string;
        };
        bnf: {
            title: string;
            alias: string;
            aliasTitles: {
                rbnf: string;
            };
            owner: string;
        };
        bqn: {
            title: string;
            owner: string;
        };
        brainfuck: {
            title: string;
            owner: string;
        };
        brightscript: {
            title: string;
            owner: string;
        };
        bro: {
            title: string;
            owner: string;
        };
        bsl: {
            title: string;
            alias: string;
            aliasTitles: {
                oscript: string;
            };
            owner: string;
        };
        c: {
            title: string;
            require: string;
            owner: string;
        };
        csharp: {
            title: string;
            require: string;
            alias: string[];
            owner: string;
        };
        cpp: {
            title: string;
            require: string;
            owner: string;
        };
        cfscript: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        chaiscript: {
            title: string;
            require: string[];
            owner: string;
        };
        cil: {
            title: string;
            owner: string;
        };
        cilkc: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        cilkcpp: {
            title: string;
            require: string;
            alias: string[];
            owner: string;
        };
        clojure: {
            title: string;
            owner: string;
        };
        cmake: {
            title: string;
            owner: string;
        };
        cobol: {
            title: string;
            owner: string;
        };
        coffeescript: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        concurnas: {
            title: string;
            alias: string;
            owner: string;
        };
        csp: {
            title: string;
            owner: string;
        };
        cooklang: {
            title: string;
            owner: string;
        };
        coq: {
            title: string;
            owner: string;
        };
        crystal: {
            title: string;
            require: string;
            owner: string;
        };
        "css-extras": {
            title: string;
            require: string;
            modify: string;
            owner: string;
        };
        csv: {
            title: string;
            owner: string;
        };
        cue: {
            title: string;
            owner: string;
        };
        cypher: {
            title: string;
            owner: string;
        };
        d: {
            title: string;
            require: string;
            owner: string;
        };
        dart: {
            title: string;
            require: string;
            owner: string;
        };
        dataweave: {
            title: string;
            owner: string;
        };
        dax: {
            title: string;
            owner: string;
        };
        dhall: {
            title: string;
            owner: string;
        };
        diff: {
            title: string;
            owner: string;
        };
        django: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        "dns-zone-file": {
            title: string;
            owner: string;
            alias: string;
        };
        docker: {
            title: string;
            alias: string;
            owner: string;
        };
        dot: {
            title: string;
            alias: string;
            optional: string;
            owner: string;
        };
        ebnf: {
            title: string;
            owner: string;
        };
        editorconfig: {
            title: string;
            owner: string;
        };
        eiffel: {
            title: string;
            owner: string;
        };
        ejs: {
            title: string;
            require: string[];
            owner: string;
            alias: string;
            aliasTitles: {
                eta: string;
            };
        };
        elixir: {
            title: string;
            owner: string;
        };
        elm: {
            title: string;
            owner: string;
        };
        etlua: {
            title: string;
            require: string[];
            owner: string;
        };
        erb: {
            title: string;
            require: string[];
            owner: string;
        };
        erlang: {
            title: string;
            owner: string;
        };
        "excel-formula": {
            title: string;
            alias: string[];
            owner: string;
        };
        fsharp: {
            title: string;
            require: string;
            owner: string;
        };
        factor: {
            title: string;
            owner: string;
        };
        false: {
            title: string;
            owner: string;
        };
        "firestore-security-rules": {
            title: string;
            require: string;
            owner: string;
        };
        flow: {
            title: string;
            require: string;
            owner: string;
        };
        fortran: {
            title: string;
            owner: string;
        };
        ftl: {
            title: string;
            require: string;
            owner: string;
        };
        gml: {
            title: string;
            alias: string;
            require: string;
            owner: string;
        };
        gap: {
            title: string;
            owner: string;
        };
        gcode: {
            title: string;
            owner: string;
        };
        gdscript: {
            title: string;
            owner: string;
        };
        gedcom: {
            title: string;
            owner: string;
        };
        gettext: {
            title: string;
            alias: string;
            owner: string;
        };
        gherkin: {
            title: string;
            owner: string;
        };
        git: {
            title: string;
            owner: string;
        };
        glsl: {
            title: string;
            require: string;
            owner: string;
        };
        gn: {
            title: string;
            alias: string;
            owner: string;
        };
        "linker-script": {
            title: string;
            alias: string;
            owner: string;
        };
        go: {
            title: string;
            require: string;
            owner: string;
        };
        "go-module": {
            title: string;
            alias: string;
            owner: string;
        };
        gradle: {
            title: string;
            require: string;
            owner: string;
        };
        graphql: {
            title: string;
            optional: string;
            owner: string;
        };
        groovy: {
            title: string;
            require: string;
            owner: string;
        };
        haml: {
            title: string;
            require: string;
            optional: string[];
            owner: string;
        };
        handlebars: {
            title: string;
            require: string;
            alias: string[];
            aliasTitles: {
                mustache: string;
            };
            owner: string;
        };
        haskell: {
            title: string;
            alias: string;
            owner: string;
        };
        haxe: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        hcl: {
            title: string;
            owner: string;
        };
        hlsl: {
            title: string;
            require: string;
            owner: string;
        };
        hoon: {
            title: string;
            owner: string;
        };
        http: {
            title: string;
            optional: string[];
            owner: string;
        };
        hpkp: {
            title: string;
            owner: string;
        };
        hsts: {
            title: string;
            owner: string;
        };
        ichigojam: {
            title: string;
            owner: string;
        };
        icon: {
            title: string;
            owner: string;
        };
        "icu-message-format": {
            title: string;
            owner: string;
        };
        idris: {
            title: string;
            alias: string;
            owner: string;
            require: string;
        };
        ignore: {
            title: string;
            owner: string;
            alias: string[];
            aliasTitles: {
                gitignore: string;
                hgignore: string;
                npmignore: string;
            };
        };
        inform7: {
            title: string;
            owner: string;
        };
        ini: {
            title: string;
            owner: string;
        };
        io: {
            title: string;
            owner: string;
        };
        j: {
            title: string;
            owner: string;
        };
        java: {
            title: string;
            require: string;
            owner: string;
        };
        javadoc: {
            title: string;
            require: string[];
            modify: string;
            optional: string;
            owner: string;
        };
        javadoclike: {
            title: string;
            modify: string[];
            owner: string;
        };
        javastacktrace: {
            title: string;
            owner: string;
        };
        jexl: {
            title: string;
            owner: string;
        };
        jolie: {
            title: string;
            require: string;
            owner: string;
        };
        jq: {
            title: string;
            owner: string;
        };
        jsdoc: {
            title: string;
            require: string[];
            modify: string;
            optional: string[];
            owner: string;
        };
        "js-extras": {
            title: string;
            require: string;
            modify: string;
            optional: string[];
            owner: string;
        };
        json: {
            title: string;
            alias: string;
            aliasTitles: {
                webmanifest: string;
            };
            owner: string;
        };
        json5: {
            title: string;
            require: string;
            owner: string;
        };
        jsonp: {
            title: string;
            require: string;
            owner: string;
        };
        jsstacktrace: {
            title: string;
            owner: string;
        };
        "js-templates": {
            title: string;
            require: string;
            modify: string;
            optional: string[];
            owner: string;
        };
        julia: {
            title: string;
            owner: string;
        };
        keepalived: {
            title: string;
            owner: string;
        };
        keyman: {
            title: string;
            owner: string;
        };
        kotlin: {
            title: string;
            alias: string[];
            aliasTitles: {
                kts: string;
            };
            require: string;
            owner: string;
        };
        kumir: {
            title: string;
            alias: string;
            owner: string;
        };
        kusto: {
            title: string;
            owner: string;
        };
        latex: {
            title: string;
            alias: string[];
            aliasTitles: {
                tex: string;
                context: string;
            };
            owner: string;
        };
        latte: {
            title: string;
            require: string[];
            owner: string;
        };
        less: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        lilypond: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        liquid: {
            title: string;
            require: string;
            owner: string;
        };
        lisp: {
            title: string;
            alias: string[];
            owner: string;
        };
        livescript: {
            title: string;
            owner: string;
        };
        llvm: {
            title: string;
            owner: string;
        };
        log: {
            title: string;
            optional: string;
            owner: string;
        };
        lolcode: {
            title: string;
            owner: string;
        };
        lua: {
            title: string;
            owner: string;
        };
        magma: {
            title: string;
            owner: string;
        };
        makefile: {
            title: string;
            owner: string;
        };
        markdown: {
            title: string;
            require: string;
            optional: string;
            alias: string;
            owner: string;
        };
        "markup-templating": {
            title: string;
            require: string;
            owner: string;
        };
        mata: {
            title: string;
            owner: string;
        };
        matlab: {
            title: string;
            owner: string;
        };
        maxscript: {
            title: string;
            owner: string;
        };
        mel: {
            title: string;
            owner: string;
        };
        mermaid: {
            title: string;
            owner: string;
        };
        metafont: {
            title: string;
            owner: string;
        };
        mizar: {
            title: string;
            owner: string;
        };
        mongodb: {
            title: string;
            owner: string;
            require: string;
        };
        monkey: {
            title: string;
            owner: string;
        };
        moonscript: {
            title: string;
            alias: string;
            owner: string;
        };
        n1ql: {
            title: string;
            owner: string;
        };
        n4js: {
            title: string;
            require: string;
            optional: string;
            alias: string;
            owner: string;
        };
        "nand2tetris-hdl": {
            title: string;
            owner: string;
        };
        naniscript: {
            title: string;
            owner: string;
            alias: string;
        };
        nasm: {
            title: string;
            owner: string;
        };
        neon: {
            title: string;
            owner: string;
        };
        nevod: {
            title: string;
            owner: string;
        };
        nginx: {
            title: string;
            owner: string;
        };
        nim: {
            title: string;
            owner: string;
        };
        nix: {
            title: string;
            owner: string;
        };
        nsis: {
            title: string;
            owner: string;
        };
        objectivec: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        ocaml: {
            title: string;
            owner: string;
        };
        odin: {
            title: string;
            owner: string;
        };
        opencl: {
            title: string;
            require: string;
            modify: string[];
            owner: string;
        };
        openqasm: {
            title: string;
            alias: string;
            owner: string;
        };
        oz: {
            title: string;
            owner: string;
        };
        parigp: {
            title: string;
            owner: string;
        };
        parser: {
            title: string;
            require: string;
            owner: string;
        };
        pascal: {
            title: string;
            alias: string;
            aliasTitles: {
                objectpascal: string;
            };
            owner: string;
        };
        pascaligo: {
            title: string;
            owner: string;
        };
        psl: {
            title: string;
            owner: string;
        };
        pcaxis: {
            title: string;
            alias: string;
            owner: string;
        };
        peoplecode: {
            title: string;
            alias: string;
            owner: string;
        };
        perl: {
            title: string;
            owner: string;
        };
        php: {
            title: string;
            require: string;
            owner: string;
        };
        phpdoc: {
            title: string;
            require: string[];
            modify: string;
            owner: string;
        };
        "php-extras": {
            title: string;
            require: string;
            modify: string;
            owner: string;
        };
        "plant-uml": {
            title: string;
            alias: string;
            owner: string;
        };
        plsql: {
            title: string;
            require: string;
            owner: string;
        };
        powerquery: {
            title: string;
            alias: string[];
            owner: string;
        };
        powershell: {
            title: string;
            owner: string;
        };
        processing: {
            title: string;
            require: string;
            owner: string;
        };
        prolog: {
            title: string;
            owner: string;
        };
        promql: {
            title: string;
            owner: string;
        };
        properties: {
            title: string;
            owner: string;
        };
        protobuf: {
            title: string;
            require: string;
            owner: string;
        };
        pug: {
            title: string;
            require: string[];
            optional: string[];
            owner: string;
        };
        puppet: {
            title: string;
            owner: string;
        };
        pure: {
            title: string;
            optional: string[];
            owner: string;
        };
        purebasic: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        purescript: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        python: {
            title: string;
            alias: string;
            owner: string;
        };
        qsharp: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        q: {
            title: string;
            owner: string;
        };
        qml: {
            title: string;
            require: string;
            owner: string;
        };
        qore: {
            title: string;
            require: string;
            owner: string;
        };
        r: {
            title: string;
            owner: string;
        };
        racket: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        cshtml: {
            title: string;
            alias: string;
            require: string[];
            optional: string[];
            owner: string;
        };
        jsx: {
            title: string;
            require: string[];
            optional: string[];
            owner: string;
        };
        tsx: {
            title: string;
            require: string[];
        };
        reason: {
            title: string;
            require: string;
            owner: string;
        };
        regex: {
            title: string;
            owner: string;
        };
        rego: {
            title: string;
            owner: string;
        };
        renpy: {
            title: string;
            alias: string;
            owner: string;
        };
        rescript: {
            title: string;
            alias: string;
            owner: string;
        };
        rest: {
            title: string;
            owner: string;
        };
        rip: {
            title: string;
            owner: string;
        };
        roboconf: {
            title: string;
            owner: string;
        };
        robotframework: {
            title: string;
            alias: string;
            owner: string;
        };
        ruby: {
            title: string;
            require: string;
            alias: string;
            owner: string;
        };
        rust: {
            title: string;
            owner: string;
        };
        sas: {
            title: string;
            optional: string[];
            owner: string;
        };
        sass: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        scss: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        scala: {
            title: string;
            require: string;
            owner: string;
        };
        scheme: {
            title: string;
            owner: string;
        };
        "shell-session": {
            title: string;
            require: string;
            alias: string[];
            owner: string;
        };
        smali: {
            title: string;
            owner: string;
        };
        smalltalk: {
            title: string;
            owner: string;
        };
        smarty: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        sml: {
            title: string;
            alias: string;
            aliasTitles: {
                smlnj: string;
            };
            owner: string;
        };
        solidity: {
            title: string;
            alias: string;
            require: string;
            owner: string;
        };
        "solution-file": {
            title: string;
            alias: string;
            owner: string;
        };
        soy: {
            title: string;
            require: string;
            owner: string;
        };
        sparql: {
            title: string;
            require: string;
            owner: string;
            alias: string;
        };
        "splunk-spl": {
            title: string;
            owner: string;
        };
        sqf: {
            title: string;
            require: string;
            owner: string;
        };
        sql: {
            title: string;
            owner: string;
        };
        squirrel: {
            title: string;
            require: string;
            owner: string;
        };
        stan: {
            title: string;
            owner: string;
        };
        stata: {
            title: string;
            require: string[];
            owner: string;
        };
        iecst: {
            title: string;
            owner: string;
        };
        stylus: {
            title: string;
            owner: string;
        };
        supercollider: {
            title: string;
            alias: string;
            owner: string;
        };
        swift: {
            title: string;
            owner: string;
        };
        systemd: {
            title: string;
            owner: string;
        };
        "t4-templating": {
            title: string;
            owner: string;
        };
        "t4-cs": {
            title: string;
            require: string[];
            alias: string;
            owner: string;
        };
        "t4-vb": {
            title: string;
            require: string[];
            owner: string;
        };
        tap: {
            title: string;
            owner: string;
            require: string;
        };
        tcl: {
            title: string;
            owner: string;
        };
        tt2: {
            title: string;
            require: string[];
            owner: string;
        };
        textile: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        toml: {
            title: string;
            owner: string;
        };
        tremor: {
            title: string;
            alias: string[];
            owner: string;
            aliasTitles: {
                trickle: string;
                troy: string;
            };
        };
        turtle: {
            title: string;
            alias: string;
            aliasTitles: {
                trig: string;
            };
            owner: string;
        };
        twig: {
            title: string;
            require: string;
            owner: string;
        };
        typescript: {
            title: string;
            require: string;
            optional: string;
            alias: string;
            owner: string;
        };
        typoscript: {
            title: string;
            alias: string;
            aliasTitles: {
                tsconfig: string;
            };
            owner: string;
        };
        unrealscript: {
            title: string;
            alias: string[];
            owner: string;
        };
        uorazor: {
            title: string;
            owner: string;
        };
        uri: {
            title: string;
            alias: string;
            aliasTitles: {
                url: string;
            };
            owner: string;
        };
        v: {
            title: string;
            require: string;
            owner: string;
        };
        vala: {
            title: string;
            require: string;
            optional: string;
            owner: string;
        };
        vbnet: {
            title: string;
            require: string;
            owner: string;
        };
        velocity: {
            title: string;
            require: string;
            owner: string;
        };
        verilog: {
            title: string;
            owner: string;
        };
        vhdl: {
            title: string;
            owner: string;
        };
        vim: {
            title: string;
            owner: string;
        };
        "visual-basic": {
            title: string;
            alias: string[];
            aliasTitles: {
                vba: string;
            };
            owner: string;
        };
        warpscript: {
            title: string;
            owner: string;
        };
        wasm: {
            title: string;
            owner: string;
        };
        "web-idl": {
            title: string;
            alias: string;
            owner: string;
        };
        wgsl: {
            title: string;
            owner: string;
        };
        wiki: {
            title: string;
            require: string;
            owner: string;
        };
        wolfram: {
            title: string;
            alias: string[];
            aliasTitles: {
                mathematica: string;
                nb: string;
            };
            owner: string;
        };
        wren: {
            title: string;
            owner: string;
        };
        xeora: {
            title: string;
            require: string;
            alias: string;
            aliasTitles: {
                xeoracube: string;
            };
            owner: string;
        };
        "xml-doc": {
            title: string;
            require: string;
            modify: string[];
            owner: string;
        };
        xojo: {
            title: string;
            owner: string;
        };
        xquery: {
            title: string;
            require: string;
            owner: string;
        };
        yaml: {
            title: string;
            alias: string;
            owner: string;
        };
        yang: {
            title: string;
            owner: string;
        };
        zig: {
            title: string;
            owner: string;
        };
    };
    plugins: {
        meta: {
            path: string;
            link: string;
        };
        "line-highlight": {
            title: string;
            description: string;
        };
        "line-numbers": {
            title: string;
            description: string;
            owner: string;
        };
        "show-invisibles": {
            title: string;
            description: string;
            optional: string[];
        };
        autolinker: {
            title: string;
            description: string;
        };
        wpd: {
            title: string;
            description: string;
        };
        "custom-class": {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
        };
        "file-highlight": {
            title: string;
            description: string;
            noCSS: boolean;
        };
        "show-language": {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
            require: string;
        };
        "jsonp-highlight": {
            title: string;
            description: string;
            noCSS: boolean;
            owner: string;
        };
        "highlight-keywords": {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
        };
        "remove-initial-line-feed": {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
        };
        "inline-color": {
            title: string;
            description: string;
            require: string;
            owner: string;
        };
        previewers: {
            title: string;
            description: string;
            require: string;
            owner: string;
        };
        autoloader: {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
        };
        "keep-markup": {
            title: string;
            description: string;
            owner: string;
            optional: string;
            noCSS: boolean;
        };
        "command-line": {
            title: string;
            description: string;
            owner: string;
        };
        "unescaped-markup": {
            title: string;
            description: string;
        };
        "normalize-whitespace": {
            title: string;
            description: string;
            owner: string;
            optional: string;
            noCSS: boolean;
        };
        "data-uri-highlight": {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
        };
        toolbar: {
            title: string;
            description: string;
            owner: string;
        };
        "copy-to-clipboard": {
            title: string;
            description: string;
            owner: string;
            require: string;
            noCSS: boolean;
        };
        "download-button": {
            title: string;
            description: string;
            owner: string;
            require: string;
            noCSS: boolean;
        };
        "match-braces": {
            title: string;
            description: string;
            owner: string;
        };
        "diff-highlight": {
            title: string;
            description: string;
            owner: string;
            require: string;
        };
        "filter-highlight-all": {
            title: string;
            description: string;
            owner: string;
            noCSS: boolean;
        };
        treeview: {
            title: string;
            description: string;
            owner: string;
        };
    };
};

type TokenObject = {
    pattern: RegExp;
    /**
     * If `true`, then the first capturing group of `pattern` will (effectively) behave as a lookbehind
     * group meaning that the captured text will not be part of the matched text of the new token.
     */
    lookbehind?: boolean | undefined;
    /**
     * Whether the token is greedy.
     *
     * @default false
     */
    greedy?: boolean | undefined;
    /**
     * An optional alias or list of aliases.
     */
    alias?: string | string[] | undefined;
    /**
     * The nested tokens of this token.
     *
     * This can be used for recursive language definitions.
     *
     * Note that this can cause infinite recursion.
     */
    inside?: Grammar | undefined;
};
type TokenRule = RegExp | TokenObject;
type Grammar = {
    [Key in DefinedGrammarToken]?: TokenRule[];
} & {
    [key: string]: TokenRule[];
};
type HighlightCustomLanguageOptions<AllAlias extends string> = {
    /**
     * The initial definitions of the language.
     *
     * It can be a `string` referencing a language that already exists,
     * an instance of `HighlightCustomLanguage` or an object of type `grammar`.
     */
    grammar?: Grammar | HighlightCustomLanguage<any, any> | HighlightLanguageComponent;
    /**
     * The language's title, if `replaceAliasOrTitles` is `false`
     * it will not replace the extended language' alias.
     */
    title?: string;
    /**
     * Indicates whether the `alias`, `title` and `aliasTitles`
     * from the extended definition should be kept.
     */
    replaceAliasOrTitles?: boolean;
    /**
     * The language's alias titles, if `replaceAliasOrTitles` is `false` it will
     * just complement the extended language' alias titles.
     */
    aliasTitles?: {
        [Key in AllAlias]?: string;
    };
};
declare class HighlightCustomLanguage<Name extends string, Alias extends string> {
    name: Name;
    title?: string;
    alias: Alias[];
    aliasTitles?: {
        [Key in Alias]?: string;
    };
    grammar: Grammar;
    /**
     * Create a new language definition
     *
     * @param {string} languageName - the language's name, if it already exists it will replace the default settings.
     * @param {string[]} alias - the language's alias, if `replaceAliasOrTitles` is `false` it will just complement the extended language' alias.
     *
     * @param {Grammar | HighlightCustomLanguage<any, any> | HighlightLanguageComponent} options.grammar - the initial definitions of the language. It can be a `string` referencing a language that already exists, an instance of `HighlightCustomLanguage` or an object of type `grammar`.
     * @param {boolean} [options.replaceAliasOrTitles=false] - a `boolean` that indicates whether the `alias`, `title` and `aliasTitles` from the extended definition should be kept.
     * @param {string} options.title - the language's title, if `replaceAliasOrTitles` is `false` it will not replace the extended language' alias.
     * @param {Object} options.aliasTitles - the language's alias titles, if `replaceAliasOrTitles` is `false` it will just complement the extended language' alias titles.
     */
    constructor(languageName: Name, alias: Alias[], { grammar, aliasTitles, title, replaceAliasOrTitles, }?: HighlightCustomLanguageOptions<Alias>);
    /**
     * Creates a new token within language definitions
     *
     * @param {GrammarToken} key - the token's name
     * @param {TokenRule[]} rules - the token's rules
     */
    createToken(key: GrammarToken, rules: TokenRule[]): void;
    /**
     * Delete a token within language definitions
     *
     * @param {GrammarToken} key - the token's name
     */
    deleteToken(key: GrammarToken): void;
    /**
     * Get a token from language definitions
     *
     * @param {GrammarToken} key - the token's name
     */
    getToken(key: GrammarToken): TokenRule[] | undefined;
    /**
     * Looks up a token within language definitions and replaces a
     * rule from its list.
     *
     * If the token is not a list (in this case, it will be a regex,
     * which is possible in Prism.js default definitions) this function
     * will transform it into a list since the established standard of this
     * library is that the value of tokens it must be a list.
     *
     * Transforming the value into a list does not change its operation s
     * ince its settings are passed to index `0` of the list.
     *
     * @param {GrammarToken} key - the target token
     * @param {GrammarToken | number} aliasOrIndex - the index of your rules, if it is not a list you can pass the value `0`. It also accepts an alias in case it is a list.
     * @param {Function} format - function that need to return the new token rule
     */
    replaceTokenRule(key: GrammarToken, aliasOrIndex: GrammarToken | number, format: (oldTokenRule: TokenRule) => TokenRule): void;
    /**
     * Looks for a token in the language definitions and removes a
     * rule from its list.
     *
     * If the token is not a list (in this case, it will be a regex,
     * which is possible in Prism.js default definitions) this function
     * will transform it into a list since the established standard of this
     * library is that the value of tokens it must be a list.
     *
     * Transforming the value into a list does not change its operation s
     * ince its settings are passed to index `0` of the list.
     *
     * If there is no item left in the list, the token will be deleted!
     *
     * @param {GrammarToken} key - the target token
     * @param {GrammarToken | number} aliasOrIndex - the index of token rules. It also accepts an alias in case it is a list.
     */
    deleteTokenRule(key: GrammarToken, aliasOrIndex: GrammarToken | number): void;
    /**
     * Looks for a token in the language definitions and adds a
     * rule to its list.
     *
     * If the token is not a list (in this case, it will be a regex,
     * which is possible in Prism.js default definitions) this function
     * will transform it into a list since the established standard of this
     * library is that the value of tokens it must be a list.
     *
     * Transforming the value into a list does not change its operation s
     * ince its settings are passed to index `0` of the list.
     *
     * @param {GrammarToken} key - the target token
     * @param {TokenRule} rule - the new rule
     */
    addTokenRule(key: GrammarToken, rule: TokenRule): void;
    load(): void;
}

declare function objectToArray<ArrayType = any[]>(object: object): ArrayType;

declare function isCustomLanguage<Value, Name extends string, Alias extends string>(object: Value | HighlightCustomLanguage<Name, Alias>): object is HighlightCustomLanguage<Name, Alias>;

declare function loadComponents(language: HighlightLanguageInput, externalLanguages: HighlightCustomLanguage<any, any>[]): void;

type CorePluginSettings = {
    showTabulations?: boolean;
};
declare const corePlugin: (settings?: CorePluginSettings) => HighligthPlugin<CorePluginSettings>;

type HighlightDefaultTheme = keyof typeof themes;
type EditEvent<Type extends "change" | "focus" = "change"> = Type extends "change" ? KeyboardEvent<HTMLTextAreaElement> | ChangeEvent<HTMLTextAreaElement> : FocusEvent<HTMLTextAreaElement>;

interface HighlightProps extends ComponentProps<typeof HighlightContainer> {
    /**
     * The code
     */
    code: string;
    /**
     * If `true` the library will not load the standard definitions of languages
     * established by the author.
     *
     * In that case the library will use the default Prism.js settings.
     *
     * This property does not disable custom definitions passed in `externalLanguages´
     *
     * @default false
     */
    disableDefaultCustomLanguages?: boolean;
    /**
     * Theme used on render the code.
     * Can be a `string` or a `HighlightTheme` object.
     *
     * @default "oneDark"
     */
    theme?: HighlightDefaultTheme | HighlightTheme;
    /**
     * language used on render the code.
     * Can be the language's `aliases` or `titles`.
     */
    language: HighlightLanguageInput;
    /**
     * Custom languages that can be used to render the code.
     * You still need to set the language.
     *
     * It currently does not support definitions of languages
     * not listed.
     */
    externalLanguages?: HighlightCustomLanguage<any, any>[];
    showNumbers?: boolean;
    showNumbersBorder?: boolean;
    textareaClassName?: string;
    numbersContainerClassName?: string;
    numbersClassName?: string;
    /**
     * In work...
     */
    plugins?: HighligthPlugin<any>[];
    /**
     * If `true` the content can be edited
     * @default false
     */
    editable?: boolean;
    /**
     * Function called when editing content
     */
    onEdit?: (e: EditEvent<"change">) => void;
    onEnterEditMode?: (e: EditEvent<"focus">) => void;
    onExitEditMode?: (e: EditEvent<"focus">) => void;
    /**
     * Textarea placeholder.
     *
     * The textarea will not set the size inside the component, so you may need
     * to set a minimum size for the component to display the placeholder properly.
     */
    placeholder?: string;
    /**
     * Number of spaces in a tab
     *
     * @default 2
     */
    tabSize?: number;
}
declare const highlightCustomLanguages: {
    javascript: HighlightCustomLanguage<"javascript", never>;
    jsx: HighlightCustomLanguage<"jsx", never>;
};

type CoreHighlightProps = Pick<HighlightProps, "editable" | "tabSize" | "language" | "showNumbers" | "theme">;
declare function Highlight({ code, theme, language, showNumbers, tabSize, placeholder, onEdit, onEnterEditMode, onExitEditMode, editable, showNumbersBorder, textareaClassName, numbersContainerClassName, disableDefaultCustomLanguages, externalLanguages, numbersClassName, plugins, ...rest }: HighlightProps): JSX.Element;

export { CoreHighlightProps, DangerousStyleEntry, DefinedGrammarToken, DivProps, EditEvent, Grammar, GrammarToken, Highlight, HighlightCustomLanguageOptions, HighlightCustomTheme, HighlightDefaultTheme, HighlightLanguageComponent, HighlightLanguageInput, HighlightProps, HighlightTheme, HighlightThemePlain, HighlightThemeStyle, HighligthPlugin, HighligthPluginData, LineInputProps, LineOutputProps, SpanProps, StyleEntry, StyleObj, Token, TokenInputProps, TokenObject, TokenOutputProps, TokenRule, corePlugin, getAllLanguagesComponents, getAllLanguagesInputs, getComponents, highlightCustomLanguages, isCustomLanguage, loadComponents, objectToArray, themes };
